package cn.estsh.i3plus.pojo.mes.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.ColumnDefault;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * @Description :
 * @Reference :
 * @Author : joke
 * @CreateDate : 2020-03-06 10:01 上午
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "MES_QUEUE_JIT_PLAN_BOM")
@Api("MES_客户JIT预装队列BOM")
public class MesQueueJitPlanBom extends BaseBean implements Serializable {

    private static final long serialVersionUID = 2037991315471333415L;

    @Column(name = "JIS_PLAN_NO")
    @ApiParam("队列编号")
    private String jisPlanNo;

    @Column(name = "PRODUCE_CTGY_CODE")
    @ApiParam("产品位置代码")
    private String produceCtgyCode;

    @Column(name = "PART_NO")
    @ApiParam("物料号")
    private String partNo;

    @Column(name = "CUST_PART_NO")
    @ApiParam("客户物料号")
    private String custPartNo;

    @Column(name = "DOCK_NO")
    @ApiParam("道口")
    private String dockNo;

    @Column(name = "QTY", columnDefinition = "decimal(18,8)")
    @ColumnDefault("0")
    @ApiParam("用量")
    private Double qty;
}
