package cn.estsh.i3plus.pojo.mes.model;

import io.swagger.annotations.ApiParam;
import lombok.Data;

import java.util.List;

@Data
public class MgnBoardListModel {

    @ApiParam("产线产量汇总")
    private List<MgnBoardYieldModel> centerYieldList;

    @ApiParam("月度产量汇总")
    private List<MgnBoardYieldModel> monthlyYieldList;

    @ApiParam("当班计划产量")
    private Double shiftPlanYield;

    @ApiParam("当班实际产量")
    private Double shiftActualYield;

    @ApiParam("时间小时")
    private String currentMinTime;

    /**
     * 开班时间到当前时间按小时累计计划数量
     */
    @ApiParam("每小时计划产量")
    private Double minPlanYield;

    /**
     * 开班时间到当前时间按小时累计实际数量
     */
    @ApiParam("每小时实际产量")
    private Double minActualYield;

    @ApiParam("计划完成率")
    private String planCompleteRate;

    @ApiParam("呼叫异常数量")
    private Integer exceptQty;

    @ApiParam("响应异常数量")
    private Integer responseQty;

    @ApiParam("正常数量")
    private Integer normalQty;

    @ApiParam("产线")
    private String workCenterCode;

    @ApiParam("车间")
    private String areaCode;

    @ApiParam("颜色")
    private String color;

    @ApiParam("产线集合")
    private List<MgnBoardListColorModel> workCenterList;

}
