package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.annotation.DynamicField;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description :客户信息表
 * @Reference :
 * @Author : hansen.ke
 * @CreateDate : 2018-11-06 17:16
 * @Modify:
 **/
@Data
@Entity
@Table(name="BAS_CUSTOMER")
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Api(value="客户信息表",description = "客户信息表")
public class BasCustomer extends BaseBean {

    private static final long serialVersionUID = -1980207700343546396L;
    @Column(name = "CUST_NO")
    @ApiParam(value = "客户编码")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT)
    private String custNo;

    @Column(name = "CUST_NAME")
    @ApiParam(value = "客户简称")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT, isRequire = 2)
    private String custName;

    @Column(name = "CUST_DESC")
    @ApiParam(value = "客户全称")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT)
    private String custDesc;

    @Column(name = "CUST_ADDR")
    @ApiParam(value = "客户地址")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT, isRequire = 2)
    private String custAddr;

    @Column(name = "CUST_OWNER")
    @ApiParam(value = "联系人")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT, isRequire = 2)
    private String custOwner;

    @Column(name = "CUST_EMAIL")
    @ApiParam(value = "邮箱")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT, isRequire = 2)
    private String custEmail;

    @Column(name = "CUST_TEL")
    @ApiParam(value = "电话号码")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT, isRequire = 2)
    private String custTel;

    @Column(name = "CUST_FAX")
    @ApiParam(value = "传真")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT, isRequire = 2)
    private String custFax;

    @Column(name = "SAFETY_STOCK")
    @ApiParam(value = "安全库存")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.DATETIME, isRequire = 2)
    private Double safetyStock;
}
