package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.annotation.DynamicField;
import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
 * @Description : 领料时长分区
 * @Reference :
 * @Author : puxiao.liao
 * @CreateDate : 2020-10-21 19:21
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name = "WMS_PICKING_WINDOW_TIME")
@Api("领料时长分区")
public class WmsPickingWindowTime extends BaseBean {

    private static final long serialVersionUID = 9214639813072592714L;

    @Column(name = "SHIFT_NO")
    @ApiParam("班次编码")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.TEXT)
    private String shiftNo;

    @Column(name = "START_TIME")
    @ApiParam("开始时间")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.DATETIME)
    private String startTime;

    @Column(name = "END_TIME")
    @ApiParam("结束时间")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.DATETIME)
    private String endTime;

    @Column(name = "LATEST_END_TIME")
    @ApiParam("最晚领料时间")
    @DynamicField(webFieldType = CommonEnumUtil.FIELD_TYPE.DATETIME)
    private String latestEndTime;

    @Transient
    @ApiParam("班次开始时间")
    private String shiftStartTime;

    @Transient
    @ApiParam("班次结束时间")
    private String shiftEndTime;

    @Transient
    @ApiParam("源存储区代码")
    public String srcZoneNo;

    @Transient
    @ApiParam("目标库位代码")
    public String destLocateNo;




    public WmsPickingWindowTime() {
    }

    public WmsPickingWindowTime(Long id, String shiftNo, String startTime, String endTime, String latestEndTime, String shiftStartTime, String shiftEndTime, String createDatetime, String modifyDatetime, Integer isDeleted, Integer isValid) {
        this.id = id;
        this.shiftNo = shiftNo;
        this.startTime = startTime;
        this.endTime = endTime;
        this.latestEndTime = latestEndTime;
        this.shiftStartTime = shiftStartTime;
        this.shiftEndTime = shiftEndTime;
        this.createDatetime = createDatetime;
        this.modifyDatetime = modifyDatetime;
        this.isDeleted = isDeleted;
        this.isValid = isValid;
    }

}